/**
 * ZapWork - OpenAPI 3.0
 * Send messages with ZapWork
 *
 * The version of the OpenAPI document: 1.0.11
 * Contact: suporte@multiplica.me
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Error from './Error';
import Message from './Message';
import SuccessMessage from './SuccessMessage';

/**
 * The SendMessage200Response model module.
 * @module model/SendMessage200Response
 * @version 1.0.11
 */
class SendMessage200Response {
    /**
     * Constructs a new <code>SendMessage200Response</code>.
     * @alias module:model/SendMessage200Response
     * @implements module:model/SuccessMessage
     * @implements module:model/Error
     * @implements module:model/Message
     */
    constructor() { 
        SuccessMessage.initialize(this);Error.initialize(this);Message.initialize(this);
        SendMessage200Response.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>SendMessage200Response</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/SendMessage200Response} obj Optional instance to populate.
     * @return {module:model/SendMessage200Response} The populated <code>SendMessage200Response</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new SendMessage200Response();
            SuccessMessage.constructFromObject(data, obj);
            Error.constructFromObject(data, obj);
            Message.constructFromObject(data, obj);

            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'Number');
            }
            if (data.hasOwnProperty('content')) {
                obj['content'] = ApiClient.convertToType(data['content'], 'String');
            }
            if (data.hasOwnProperty('api_key')) {
                obj['api_key'] = ApiClient.convertToType(data['api_key'], 'String');
            }
            if (data.hasOwnProperty('number')) {
                obj['number'] = ApiClient.convertToType(data['number'], 'Number');
            }
            if (data.hasOwnProperty('message')) {
                obj['message'] = ApiClient.convertToType(data['message'], 'String');
            }
            if (data.hasOwnProperty('type')) {
                obj['type'] = ApiClient.convertToType(data['type'], 'String');
            }
        }
        return obj;
    }


}

/**
 * @member {Number} status
 */
SendMessage200Response.prototype['status'] = undefined;

/**
 * @member {String} content
 */
SendMessage200Response.prototype['content'] = undefined;

/**
 * @member {String} api_key
 */
SendMessage200Response.prototype['api_key'] = undefined;

/**
 * @member {Number} number
 */
SendMessage200Response.prototype['number'] = undefined;

/**
 * @member {String} message
 */
SendMessage200Response.prototype['message'] = undefined;

/**
 * Order Status
 * @member {module:model/SendMessage200Response.TypeEnum} type
 */
SendMessage200Response.prototype['type'] = undefined;


// Implement SuccessMessage interface:
/**
 * @member {Number} status
 */
SuccessMessage.prototype['status'] = undefined;
/**
 * @member {String} content
 */
SuccessMessage.prototype['content'] = undefined;
// Implement Error interface:
/**
 * @member {Number} status
 */
Error.prototype['status'] = undefined;
/**
 * @member {String} content
 */
Error.prototype['content'] = undefined;
// Implement Message interface:
/**
 * @member {String} api_key
 */
Message.prototype['api_key'] = undefined;
/**
 * @member {Number} number
 */
Message.prototype['number'] = undefined;
/**
 * @member {String} message
 */
Message.prototype['message'] = undefined;
/**
 * Order Status
 * @member {module:model/Message.TypeEnum} type
 */
Message.prototype['type'] = undefined;



/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
SendMessage200Response['TypeEnum'] = {

    /**
     * value: "text"
     * @const
     */
    "text": "text",

    /**
     * value: "voice"
     * @const
     */
    "voice": "voice",

    /**
     * value: "file"
     * @const
     */
    "file": "file",

    /**
     * value: "image"
     * @const
     */
    "image": "image",

    /**
     * value: "buttons"
     * @const
     */
    "buttons": "buttons"
};



export default SendMessage200Response;

